/*
 * jQuery Anime Switch 0.0.1
 * http://tukumemo.com/
 * Copyright 2014 TUKUMEMO
 * license: http://www.opensource.org/licenses/mit-license.php
 */
;(function($) {
    var pgName = 'animeSwitch',
        count = 0;
    //
    //css3が使える場合
    var cssParam = {},
        isCssAnime = true;
    var cssInit = function() {
        var style = document.createElement('div').style;
        if ('webkitAnimation' in style) {
            cssParam.vender = '-webkit-';
            cssParam.venderFunc = 'webkitAnimationEnd';
        } else if ('animation' in style) {
            cssParam.vender = '';
            cssParam.venderFunc = 'animationend';
        } else {
            isCssAnime = false;
        }
    };
    cssInit();
    //
    //本体plugin
    $[pgName] = function(elem, option,count) {
        var plugin = this,
            $elem = $(elem),
            defaults = { //デフォルト設定
                second: 30, //切り替え秒
                width: 100, //幅
                height: 100, //高さ
                frame: 10, //コマ数(1-)
                xPos: 0, //X座標(0-)
                yPos: 0, //Y座標(0-)
                course: 'y', //方向
                loop: true, //ループ
                onComplete: function() {}
            },
            w = 0, //wカレント
            h = 0, //hカレント
            nw = 0, //wゴール,
            ny = 0, //hゴール
            cf, //カレントフレーム
            itId = [], //インターバルID
            animeName = 'anime' + count,//css3 anime name
            css3Style; //css3 style

        plugin.settings = {};
        //
        //style tag 確保
        var cssStyleSet = function() {
            css3Style = document.createElement('style');
            css3Style.setAttribute('type', 'text/css');
            $(css3Style).appendTo('head')[0];
        };
        var cssAnimeAdd = function() {
            var loopCount;
            if (plugin.settings.loop){
                loopCount = 'infinite';
            }else{
                loopCount = 1;
            }
            $elem.css(cssParam.vender + 'animation-play-state','running');
            $elem.css(cssParam.vender + 'animation', animeName + ' ' + loopCount + ' ' + plugin.settings.second * (plugin.settings.frame-1) + 'ms forwards steps(' + (plugin.settings.frame-1) + ',end)');
            $elem.css('background-position','');
        };
        var cssAnimeRemove = function() {
            $elem.css(cssParam.vender + 'animation','');
            $elem.css(cssParam.vender + 'animation-play-state','paused');
            $elem.css('background-position', w + 'px ' + h + 'px');
        };
        var cssAnimeAddStart = function(){
            cssAnimeRemove();
            setTimeout(function(){
                if ($elem.css(cssParam.vender + 'animation-play-state') === 'paused'){
                    cssAnimeAdd();
                }else{
                    cssAnimeAddStart();
                }
            },plugin.settings.second);
        };

        var cssKeyframe = function() {
            if (css3Style.sheet.cssRules.length){
                css3Style.sheet.deleteRule(0);
            }
            if (plugin.settings.course == 'y') {
                w = plugin.settings.width * plugin.settings.xPos * -1;
                h = plugin.settings.height * plugin.settings.yPos * -1;
                nw = w;
                nh = plugin.settings.height * (plugin.settings.frame-1) * -1;
            } else {
                w = plugin.settings.width * plugin.settings.xPos * -1;
                h = plugin.settings.height * plugin.settings.yPos * -1;
                nw = plugin.settings.width * (plugin.settings.frame-1) * -1;
                nh = h;
            }
            css3Style.sheet.insertRule('@' + cssParam.vender + 'keyframes '+ animeName +' {0% {background-position:' + w + 'px ' + h + 'px; } 100% {background-position:' + nw + 'px ' + nh + 'px;}}', 0);
        };
        var cssEnd = function() {
            if (!plugin.settings.loop){
                plugin.settings.onComplete();
            }
        };
        var cssEndEventOn = function() {
            if (!$elem[cssParam.venderFunc]){
                $elem.on(cssParam.venderFunc, cssEnd);
            }
        };
        //
        //
        var timer = function() {
            if (plugin.settings.course == 'y') {
                w = plugin.settings.width * plugin.settings.xPos * -1;
                h = plugin.settings.height * cf * -1;
            } else {
                w = plugin.settings.width * cf * -1;
                h = plugin.settings.height * plugin.settings.yPos * -1;
            }
            $elem.css({
                backgroundPosition: w + 'px ' + h + 'px'
            });
            cf++;
            if (plugin.settings.frame <= cf) {
                cfInit();
                if (!plugin.settings.loop) plugin.pause();
                plugin.settings.onComplete();
            }
        };
        var cfInit = function() {
            cf = plugin.settings.course == 'y' ? plugin.settings.yPos : plugin.settings.xPos;
        };
        //
        //method
        plugin.start = function() {
            if (isCssAnime) {
                cssAnimeAddStart();
            } else {
                itId.push(setInterval(timer, plugin.settings.second));
            }
        };
        plugin.stop = function() {
            plugin.pause();
            if (!isCssAnime) {
                cfInit();
                timer();
            }
        };
        plugin.pause = function() {
            if (isCssAnime) {
                cssAnimeRemove();
            } else {
                for (var i = 0; i < itId.length; i += 1) {
                    clearInterval(itId[i]);
                    itId = [];
                }
            }
        };
        plugin.param = function(opt) {
            plugin.pause();
            plugin.paramSet(opt);
            plugin.start();
        };
        plugin.paramSet = function(opt) {
            plugin.settings = $.extend(plugin.settings, opt);
            if (isCssAnime) {
                cssKeyframe();
            }else{
                cfInit();
            }
        };
        var init = function() {
            plugin.settings = $.extend(defaults, option);
            if (isCssAnime) {
                cssStyleSet();
                cssKeyframe();
                cssEndEventOn();
            }else{
                cfInit();
            }
        };
        init();
    };
    $.fn[pgName] = function(option) {
        return this.each(function() {
            if (undefined == $(this).data(pgName)) {
                count++;
                var plugin = new $[pgName](this, option,count);
                $(this).data(pgName, plugin);
            }
        });
    };
})(jQuery, document, window);